import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.Box.*;
import javax.swing.event.*;

/**
 * Motif Memento et Adapteur.
 *
 */


 /*	* interface implementable MultiList du motif adapteur.
 	*
 	*/

interface MultiList{
	public int currentItem();
	public void insertListOfStrings(Object list);
	public void removeItemAt(Object comp);
	public Object getSelectItems();


	}


  /** Application du motif adapteur.
	*
	*/

class BList extends Box implements MultiList{
        private  JComboBox jlist;
		private int taille;

       	//attribut pour la restauration de la combobox.
       	private  String []originator;



        public BList(int taille,JComboBox jlist,String []originator){
        super(taille);
        this.taille=taille;
        this.jlist=jlist;
		this.originator=originator;
        this.add(jlist);
        }





	public JComboBox getList(){return jlist;}


	//Methode de restauration du motif memento.
	public void restore(){
	   this.jlist.removeAllItems();
	   for (int j=0;j<this.taille;j++)
	   	  this.jlist.addItem(this.originator[j]);



	}


    public int currentItem(){
            if (jlist.getComponentCount()==0)
                return 0;
            return (jlist.getComponentCount()-1);



		}
	public void insertListOfStrings(Object list){
        jlist.addItem(list.toString());


        this.repaint();


        }

	public void removeItemAt(Object comp){
        try{
        jlist.removeItem(comp);
        }catch (Exception e){}}

        public Object  getSelectItems(){

        return jlist.getSelectedItem();
        }


	}


public class myWidget extends JFrame implements ActionListener,MouseListener,MouseMotionListener{

	private BList blist1,blist2;
	private JButton b1,b2;
	private static String []tab1={"toto","tata"},tab2={"dodo","dada"};

	public myWidget(String name){
		super(name);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JPanel pane=new JPanel();
		pane.setLayout(new BorderLayout());
		Box box1=Box.createVerticalBox();
		blist1=new BList(tab1.length,new JComboBox(tab1),tab1);
		blist2=new BList(tab2.length,new JComboBox(tab2),tab2);
		b1=new JButton("-->");
		b2=new JButton("<--");
		this.addMouseListener(this);
		this.addMouseMotionListener(this);
		b1.addActionListener(this);
		b2.addActionListener(this);
		box1.add(blist1);
		box1.add(box1.createVerticalStrut(25));
		box1.add(b1);
		pane.add(box1,BorderLayout.WEST);
		Box box2=Box.createVerticalBox();
		box2.add(blist2);
		box2.add(box2.createVerticalStrut(25));
		box2.add(b2);
		pane.add(box2,BorderLayout.EAST);
		setContentPane(pane);
		this.pack();
		this.setResizable(false);
		this.setVisible(true);
	}


//Methode de restauration du motif memento.

	public void restore(){
		this.blist1.restore();
		this.blist2.restore();

		}

	public void actionPerformed(ActionEvent e){
		Object o=e.getSource();
		if (o == b1){
		this.blist2.insertListOfStrings(this.blist1.getList().getSelectedItem());
		this.blist1.removeItemAt(this.blist1.getList().getSelectedItem());

		}
		else if (o == b2){
		this.blist1.insertListOfStrings(this.blist2.getList().getSelectedItem());
		this.blist2.removeItemAt(this.blist2.getList().getSelectedItem());

		}
		}

	public void mouseDragged(MouseEvent e){}
	public void mouseMoved(MouseEvent e){}
	public void mouseClicked(MouseEvent e){restore();}
	public void mousePressed(MouseEvent e){}
	public void mouseReleased(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}




	public static void main(String [] args){

		myWidget widget=new myWidget("Design Patterns");


	}

}


