import java.io.*;

public class InflateContext {

private InputStream in;
private OutputStream out;
private String filename;
InflateStrategy strategy;


public void setData(String filename,InputStream in,OutputStream out){
this.filename=filename;
this.in=in;
this.out=out;
}


public void setZipStrategy(){
	strategy=new ZipStrategy();

	}

public void setGZipStrategy(){
	strategy=new GZipStrategy();
	}



public void inflate()throws IOException{

	strategy.inflate(filename,in,out);
	}



public static void main(String args[]){
        try{
	InflateContext inflate=new InflateContext();
	System.out.println("Entrer le nom du fichier:");
	BufferedReader in=new BufferedReader(new InputStreamReader(System.in));
        String file=in.readLine();;
	inflate.setData(file,new FileInputStream(file),new FileOutputStream(file+".tar.gz"));
	inflate.setZipStrategy();
	inflate.inflate();
        }catch (IOException e){}

	}

}